<?
/*
 * (C) Copyright 2003 Krzysztof Gibas <sdas (at) gibas org>
 *                      - current maintainer
 *               2001 Gonthar <gonthar (at) moon net pl>
 *                      - developed scr_ipfm-0.1
 *
 * scr_ipfm generates graphical statistics from ipfm logs.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This  program is  distributed in the  hope  that  it will be useful,
 * but  WITHOUT  ANY  WARRANTY;  without even  the  implied warranty of
 * MERCHANTABILITY  or  FITNESS  FOR  A  PARTICULAR  PURPOSE.  See  the
 * GNU General Public License for more details.
 *
 * You  should  have  received a copy of the GNU General Public License
 * along  with  this  program;  if  not,  write  to  the  Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
 * USA.
 *
 * $Id: functions.php,v 1.82 2003/11/13 17:04:48 gibas Exp $
 */

function calc($bytes = "0") { 
        $unit = 0;
	
	while($bytes > 1024) { 
	    $bytes /= 1024;
	    $unit++;
	}
	
	$bytes = round($bytes, 2);
	
	switch($unit) {
	    case "0":
		$unit = "b";
		break;
	    case "1":
		$unit = "kB";
		break;
	    case "2":
	        $unit = "MB";
	        break;
	    case "3":
	        $unit = "GB";
	        break;
	    case "4":
		$unit = "TB";
		break;
	    default:
	        $unit = "MB";
	        break;
	}
	return("$bytes $unit"); 
}

function invert_flag($flag) {
    if ($flag == "ASC") {
        $flag = "DESC";
    }
    else {
        $flag = "ASC";
    }
    return $flag;
}

function sortbycol($in, $s, $flag) {
    $tmp = "";
    
    for($i = 0; $i < count($in); $i++) {
	$ex = preg_split("/\s+/", $in[$i]);
	$tmp[] = $ex[$s];
    }
    if ($tmp) {
	array_multisort($tmp, $flag, $in);
	unset($tmp);
    }
    return $in;
}


function calc_scale($part, $s) {
    $parts = preg_split("/\s+/", $part);
    
    $scale = 0;
    $scale = $parts[$s] / 800;
    return $scale;
}

function check_dir_exists($dir = "") {
    if (!is_dir($dir)) {
        echo "<br /><p class=\"error\">directory: $dir - Bad data submitted. This directory doesn't exists. Check it in conf.php.</p><br />";
        exit();
    }
}

function check_file_exists($file = "", $what = "") {
    if(!file_exists($file)) {
        echo "<br /><p class=\"error\">file: $file - Bad data submitted. Logs for that $what don't exists.</p><br />";
        exit();
    }
}

function create_ar_years() {
    global $ipfm_log_dir;
    global $name;
    
    $ar_years = array();

    if ($handle = opendir("$ipfm_log_dir")) {
        while (false != ($file = readdir($handle))) {
            if ($file != "." && $file != ".." && $file != "ipfm-global.log") {
                $var = split("\.", $file);
                $name = split('-', $var[0]);
                
                if (stristr("$file", "ipfm-global-")) {
                    if(!in_array($name[2], $ar_years)) {
                        array_push($ar_years, "$name[2]");
                    }
                }
            }
        }
    }
    closedir($handle);
    asort($ar_years);
    
    return($ar_years);
}

function create_ar_months() {
    global $ipfm_log_dir;
    global $ar_years;
    global $name;
    
    $ar_months = array();
   
    if ($handle = opendir("$ipfm_log_dir")) {
        while (false != ($file = readdir($handle))) {
            if ($file != "." && $file != ".." && $file != "ipfm-global.log") {
                $var = split("\.", $file);
                $name = split('-', $var[0]);

                if (isset($_GET['year'])) {
                    if (stristr("$file", "ipfm-global-" . $_GET['year'] . "-")) {
                        if(!in_array($name[3], $ar_months)) {
                            array_push($ar_months, "$name[3]");
                        }
                    }
                }
                else {
                    if (stristr("$file", "ipfm-global-" . end($ar_years) . "-")) {
                        if(!in_array($name[3], $ar_months)) {
                            array_push($ar_months, "$name[3]");
                        }
                    }
                }
            }
        }
    }
    closedir($handle);
    asort($ar_months);
    
    return($ar_months);
}

function create_ar_days() {
    global $ipfm_log_dir;
    global $ar_years;
    global $ar_months;
    global $name;
    
    $ar_days = array();

    if ($handle = opendir("$ipfm_log_dir")) {
        while (false != ($file = readdir($handle))) {
            if ($file != "." && $file != ".." && $file != "ipfm-global.log") {
                $var = split("\.", $file);
                $name = split('-', $var[0]);

                if (isset($_GET['year']) && isset($_GET['month'])) {
                    if (stristr("$file", "ipfm-global-" . $_GET['year'] . "-" . $_GET['month'] . "-")) {
                        if(!in_array($name[4], $ar_days)) {
                            array_push($ar_days, "$name[4]");
                        }
                    }
                }
                elseif (isset($_GET['year']) && !isset($_GET['month'])) {
                    if (stristr("$file", "ipfm-global-" . $_GET['year'] . "-" . end($ar_months) . "-")) {
                        array_push($ar_days, "$name[4]");
                    }
                }
                else {
                    if (stristr("$file", "ipfm-global-" . end($ar_years) . "-" . end($ar_months) . "-")) {
                        if(!in_array($name[4], $ar_days)) {
                            array_push($ar_days, "$name[4]");
                        }
                    }
                }
            }
        }
    }
    closedir($handle);
    asort($ar_days);

    return($ar_days);
}

function set_style_flag_s() {
    global $host_style;
    global $in_style;
    global $out_style;
    global $total_style;
    global $host_flag;
    global $in_flag;
    global $out_flag;
    global $total_flag;
    global $s;
    
    $host_style = $in_style = $out_style = $total_style = "out";
    
    $host_flag = $in_flag = $out_flag = $total_flag = $_GET['flag'];

    switch($_GET['sort']) {
        case 'host':
            $s = "0";
            $host_style = "in";
            $host_flag = invert_flag($host_flag);
            break;

        case 'in':
            $s = "1";
            $in_style = "in";
            $in_flag = invert_flag($in_flag);
            break;

        case 'out':
            $s = "2";
            $out_style = "in";
            $out_flag = invert_flag($out_flag);
            break;

        case 'total':
            $s = "3";
            $total_style = "in";
            $total_flag = invert_flag($total_flag);
            break;

        default:
            $s = "3";
            $total_style = "in";
            $total_flag = invert_flag($total_flag);
    }
}


function secure_sort() {
    if (!isset($_GET['sort']) or is_numeric($_GET['sort']) or strlen($_GET['sort']) == 0) {
        $_GET['sort'] = "total";
    }
    else {
        $_GET['sort'] = addslashes($_GET['sort']);
    }
}

function secure_flag() {
    if (!isset($_GET['flag']) or is_numeric($_GET['flag']) or strlen($_GET['flag']) == 0) {
        $_GET['flag'] = "ASC";
    }
    else {
        $_GET['flag'] = addslashes($_GET['flag']);
    }
}

function secure_host() {
    if (!isset($_GET['host']) or strlen($_GET['host']) == 0) {
        $_GET['host'] = "";
    }
    else {
        $_GET['host'] = addslashes($_GET['host']);
    }
}
    
function secure_year() {
    global $ar_years;
    
    if (!isset($_GET['year']) or !is_numeric($_GET['year']) or strlen($_GET['year']) == 0) {
        $_GET['year'] = end($ar_years);
    }
    else {
        $_GET['year'] = addslashes($_GET['year']);
    }
}

function secure_month() {
    global $ar_months;
    
    if (!isset($_GET['month']) or !is_numeric($_GET['month']) or strlen($_GET['month']) == 0) {
        $_GET['month'] = end($ar_months);
    }
    else {
        $_GET['month'] = addslashes($_GET['month']);
    }
}

function secure_day() {
    global $ar_days;

    if (!isset($_GET['day']) or !is_numeric($_GET['day']) or strlen($_GET['day']) == 0) {
        $_GET['day'] = end($ar_days);
    }
    else {
        $_GET['day'] = addslashes($_GET['day']);
    }        
}

function set_table_bg_style($element) {
   
    $element = calc($element);
    
    if(stristr($element, "B")) {
        $style = "table_bg_b";
    }
    if(stristr($element, "kB")) {
        $style = "table_bg_kb";
    }
    if(stristr($element, "MB")) {
        $style = "table_bg_mb";
    }
    if(stristr($element, "GB")) {
        $style = "table_bg_gb";
    }
    if(stristr($element, "TB")) {
        $style = "table_bg_tb";
    }
    return $style;
}

function theme_file($file = "default") {
    $file = addslashes($file);
    
    if (file_exists("themes/$file/style.css")) {
	$theme = "themes/$file/style.css";
	return $theme;
    }
}
function html_make_header_en($auto_refresh = "", $header="", $version="") {
    global $theme;
    
    echo "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>
	<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">
        <html xmlns=\"http://www.w3.org/1999/xhtml\">
	<head>
    	    <meta http-equiv=\"content-type\" content=\"text/html; charset=iso-8859-1\" />
    	    <meta http-equiv=\"content-language\" content=\"en\" />
    	    <meta name=\"description\" content=\"scr_ipfm php stats\" />
    	    <meta name=\"robots\" content=\"index\" />";

    if (isset($auto_refresh) && strlen($auto_refresh) > 0) {
        $url = $_SERVER['PHP_SELF'];
        echo "<meta http-equiv=\"refresh\" content=\"" . $auto_refresh . "; url=" . $url . "\" />";
    }
    
    echo "
    	    <title>$header generated by scr_ipfm-$version</title>
    	    <link href=\"" . theme_file($theme). "\" rel=\"stylesheet\" type=\"text/css\" />
        </head>
	<body>
    ";
}

function html_make_sum($sum_in = 0, $sum_out = 0, $sum_total = 0) {
    echo "
    <tr class=\"tablemainsum\">
        <td align=\"left\" colspan=\"2\">Sum:</td>
        <td align=\"right\">" . calc($sum_in) . "</td>
        <td align=\"right\">" . calc($sum_out) . "</td>
        <td align=\"right\">" . calc($sum_total) . "</td>
    </tr>
    </tbody>
    </table>";
}

function html_make_links_year($type = "daily") {
    global $ar_years;
    
    if (isset($_GET['host'])) {
        $type = "host=" . $_GET['host'];
    }
    else {
        $type = $type . "=1";
    }

    echo "Year: ";
    
    foreach($ar_years as $value) {
        if($value == $_GET['year']) {
            echo "<a class=\"linkred\" href=\"index.php?sort=" . $_GET['sort'] . "&amp;flag=". $_GET['flag'] . "&amp;" . $type .
                                                                                                "&amp;year=" . $value . "\">$value</a> ";
        }
        else {
            echo "<a class=\"link\" href=\"index.php?sort=" . $_GET['sort'] . "&amp;flag=". $_GET['flag'] . "&amp;" . $type . 
                                                                                                "&amp;year=" . $value . "\">$value</a> ";
        }
    }    
}

function html_make_links_month($type = "daily") {
    global $ar_months;

    if (isset($_GET['host'])) {
        $type = "host=" . $_GET['host'];
    }
    else {
        $type = $type . "=1";
    }
    
    echo "<br />Month: ";
    
    foreach($ar_months as $value) {
        if($value == $_GET['month']) {
            echo "<a class=\"linkred\" href=\"index.php?sort=" . $_GET['sort'] . "&amp;flag=". $_GET['flag'] . "&amp;" . $type .
                                                                        "&amp;year=" . $_GET['year'] . "&amp;month=" . $value . "\">$value</a> ";
        }
        else {
            echo "<a class=\"link\" href=\"index.php?sort=" . $_GET['sort'] . "&amp;flag=". $_GET['flag'] . "&amp;" . $type .
                                                                        "&amp;year=" . $_GET['year'] . "&amp;month=" . $value . "\">$value</a> ";
        }
    }
}

function html_make_links_day($type = "daily") {
    global $ar_days;

    if (isset($_GET['host'])) {
        $type = "host=" . $_GET['host'];
    }
    else {
        $type = $type . "=1";
    }
    
    echo "<br />Day: ";
    
    foreach($ar_days as $value) {
        if($value == $_GET['day']) {
            echo "<a class=\"linkred\" href=\"index.php?sort=" . $_GET['sort'] . "&amp;flag=". $_GET['flag'] . "&amp;" . $type . 
                                    "&amp;year=" . $_GET['year'] . "&amp;month=" . $_GET['month'] . "&amp;day=" . $value . "\">$value</a>  ";
        }
        else {
            echo "<a class=\"link\" href=\"index.php?sort=" . $_GET['sort'] . "&amp;flag=". $_GET['flag'] . "&amp;" . $type .
                                    "&amp;year=" . $_GET['year'] . "&amp;month=" . $_GET['month'] . "&amp;day=" . $value . "\">$value</a>  ";
        }
    }
}

function html_make_links($colored = "daily") {
    
    $class_d = "link";
    $class_dim = "link";
    $class_m = "link";
    $class_miy = "link";
    $class_y = "link";
    $class_yig = "link";
    $class_g = "link";
    
    
    switch($colored) {
        case 'daily':
            $class_d = "linkred";
            break;
        case 'dayinmonth':
            $class_dim = "linkred";
            break;
        case 'monthly':
            $class_m = "linkred";
            break;
        case 'monthinyear':
            $class_miy = "linkred";
            break;
        case 'global':
            $class_g = "linkred";
            break;
        case 'yearly':
            $class_y = "linkred";
            break;
        case 'yearinglobal':
            $class_yig = "linkred";
            break;
    }
    
    echo "
    <table class=\"makelinks\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\">
    <tbody>
    <tr>
        <td align=\"right\">Statistics: [
        <a class=\"$class_d\" href=\"index.php?daily=1\">daily</a> |
        <a class=\"$class_dim\" href=\"index.php?dayinmonth=1\">day-in-month</a> |
        <a class=\"$class_m\" href=\"index.php?monthly=1\">monthly</a> |
        <a class=\"$class_miy\" href=\"index.php?monthinyear=1\">month-in-year</a> |
        <a class=\"$class_y\" href=\"index.php?yearly=1\">yearly</a> |
        <a class=\"$class_yig\" href=\"index.php?yearinglobal=1\">year-in-global</a> |
        <a class=\"$class_g\" href=\"index.php?global=1\">global</a> ]
        </td>
    </tr>
    </tbody>
    </table>";
}

function html_make_links_graph($colored = "daily") {

    $class_d = "link";
    $class_m = "link";

    switch($colored) {
        case 'daily':
            $class_d = "linkred";
            break;
        case 'monthly':
            $class_m = "linkred";
            break;
    }

    // <a class=\"$class_d\" href=\"index.php?daily=1\">vertical</a> |
    // <a class=\"$class_m\" href=\"index.php?monthly=1\">horizontal</a> ]
    echo "
        <table class=\"makelinks\">
        <tbody>
        <tr>
            <td align=\"right\">
                [ vertical | horizontal ]
            </td>
        </tr>
        </tbody>
        </table>";
}

function html_make_result($style, $num = 0, $host = "", $in = 0, $out = 0, $total = 0) {
    
    //echo "<tr onmouseover=\"this.bgColor = '". "$table_bg_highlight_color" . "'\" onmouseout =\"this.bgColor = '" .
    //                                                                "$table_bg_color" . "'\" bgcolor=\"$table_bg_color\">
    echo "<tr class=\"$style\">
    <td>$num.</td>
    <td align=\"left\"><a class=\"link\" href=\"index.php?host=$host\">$host</a></td>
    <td align=\"right\">" . calc($in) . "</td>
    <td align=\"right\">" . calc($out) . "</td>
    <td align=\"right\">". calc($total) ."</td>
    </tr>";
}

function html_make_result_host($style, $num = 0, $host = "", $in = 0, $out = 0, $total = 0) {

    //echo "<tr onmouseover=\"this.bgColor = '". "$table_bg_highlight_color" . "'\" onmouseout =\"this.bgColor = '" .
    //                                                                "$table_bg_color" . "'\" bgcolor=\"$table_bg_color\">

    echo "<tr class=\"$style\">
    <td>$num.</td>
    <td align=\"left\">$host</td>
    <td align=\"right\">" . calc($in) . "</td>
    <td align=\"right\">" . calc($out) . "</td>
    <td align=\"right\">". calc($total) ."</td>
    </tr>";
}

function html_make_version_table($ipfm = "", $date = "", $freq = "", $int = "", $ver = "") {
    
    echo "
    <table class=\"tablebottom\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\">
    <tbody>
    <tr class=\"tablebottom\">
    <td>
	ipfm version: $ipfm -- stats for: $date -- frequency: $freq -- interface $int<br />
	Stats generated by <a class=\"link\" href=\"http://scripfm.sf.net/\">scr_ipfm v. $ver</a>
    </td>
    </tr>
    </tbody>
    </table>";
}

function html_make_empty_table() {
    echo "<table><tbody><tr><td>&nbsp;</td></tr></tbody></table>";
}

function html_make_footer() {
    echo "</body></html>";
}

function html_graph_horizon($host, $total, $total_scaled) {
    echo "<table cellspacing=\"0\" cellpadding=\"0\">
          <tbody>
	  <tr>
              <td>$host - " . calc($total) . "</td>
          </tr>
	  </tbody>
          </table>
          
          <table cellspacing=\"0\" cellpadding=\"0\">
	  <tbody>
          <tr>
              <td background=\"images/wykres-poziom-first.png\" width=\"2\" height=\"22\"></td>
              <td background=\"images/wykres-poziom.png\" width=\"$total_scaled\" height=\"22\"></td>
              <td background=\"images/wykres-poziom-end.png\" width=\"1\" height=\"22\"></td>
          </tr>
	  </tbody>
          </table>";
}

?>
