<?
/*
 * (C) Copyright 2003 Krzysztof Gibas <sdas (at) gibas org>
 *                      - current maintainer
 *               2001 Gonthar <gonthar (at) moon net pl>
 *                      - developed scr_ipfm-0.1
 *
 * scr_ipfm generates graphical statistics from ipfm logs. 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This  program is  distributed in the  hope  that  it will be useful,
 * but  WITHOUT  ANY  WARRANTY;  without even  the  implied warranty of
 * MERCHANTABILITY  or  FITNESS  FOR  A  PARTICULAR  PURPOSE.  See  the
 * GNU General Public License for more details.
 *
 * You  should  have  received a copy of the GNU General Public License
 * along  with  this  program;  if  not,  write  to  the  Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
 * USA.
 *
 * $Id: host.php,v 1.24 2003/11/13 09:05:57 gibas Exp $
 */

$sum_in = 0;
$sum_out = 0;
$sum_total = 0;

$in = 0;
$out = 0;
$total = 0;

//default values of variables.
secure_sort();
secure_flag();
secure_host();

$ar_years = create_ar_years();
$ar_months = create_ar_months();
$ar_days = create_ar_days();

secure_year();
secure_month();

$filename = "$ipfm_log_dir" . "ipfm-global-" . $_GET['year'] . "-" . $_GET['month'];

$header = "Statistics for " . $_GET['host'] . " in " . $_GET['month'] . "-" . $_GET['year'];

html_make_header_en($auto_refresh, $header, $version);

echo "<table class=\"tabletop\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\"><tbody><tr class=\"tabletop\"><td>";

html_make_links_year("host=" . $_GET['host']);
html_make_links_month("host=" . $_GET['host']);

echo "</td></tr></tbody></table>";

html_make_links("");

check_dir_exists($ipfm_log_dir);
check_file_exists($filename . "-" . end($ar_days) . ".log", "month");

//sets global variables: $*_style, $s and $*_flag
set_style_flag_s();

$_GET['flag'] = invert_flag($_GET['flag']);

echo "
<table class=\"tablebottom\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\">
<tbody>
<tr class=\"tablemain\">
    <td colspan=\"5\" align=\"right\">$header</td>
</tr>

<tr class=\"tablemain\">
    <td align=\"left\" class=\"sort\">Lp.</td>
    
    <td class=\"$host_style\" align=\"left\">
        <a class=\"sort\" href=\"index.php?host=" . $_GET['host'] . "&amp;sort=host&amp;year=" . $_GET['year'] . "&amp;month=" . $_GET['month'] . "&amp;flag=" . 
                                                                                                                $host_flag . "\">Host [date]</a> 
    </td>

    <td class=\"$in_style\" align=\"right\">
        <a class=\"sort\" href=\"index.php?host=" . $_GET['host'] . "&amp;sort=in&amp;year=" . $_GET['year'] . "&amp;month=" . $_GET['month'] . "&amp;flag=" . 
                                                                                                                $in_flag . "\">In</a> 
    </td>

    <td class=\"$out_style\" align=\"right\">
        <a class=\"sort\" href=\"index.php?host=" . $_GET['host'] . "&amp;sort=out&amp;year=" . $_GET['year'] . "&amp;month=" . $_GET['month'] . "&amp;flag=" . 
                                                                                                                $out_flag . "\">Out</a> 
    </td>

    <td class=\"$total_style\" align=\"right\">
        <a class=\"sort\" href=\"index.php?host=" . $_GET['host'] . "&amp;sort=total&amp;year=" . $_GET['year'] . "&amp;month=" . $_GET['month'] . "&amp;flag=" . 
                                                                                                                $total_flag . "\">Total</a> 
    </td>
</tr>";

$ar_results_all = array();
$ar_results = array();

$string = "";
for ($k = 0; $k < count($ar_days); $k++) {
    $filename = "$ipfm_log_dir" . "/" . "ipfm-global-$_GET[year]-$_GET[month]-$ar_days[$k]" . ".log";
    $datas = file($filename);

    for($i=0; $i < count($datas); $i++) {
    
        if(preg_match("/^# /", $datas[$i])) {

            if(strstr("$datas[$i]", " IPFM")) {
                //interface, time, version ipfm...
                $string = split(" ", $datas[$i]);
    
                //dirty hack - for old versions ipfm.
                if($string[6] == "every") {
                    $string[9] = $string[7];
                    $string[13] = $string[11];
                }
            }
        } 
        else {
            if(strlen($datas[$i]) != 0) {
                $elements = preg_split("/\s+/", $datas[$i]);
    
                $host = $elements[0];
                $in = $elements[1];
                $out = $elements[2];
                $total = $elements[3];
                
                if ($host == $_GET['host']) {
                    //$ar_results[$k][0] = "$host&nbsp;[$_GET[year]-$_GET[month]-$ar_days[$k]". "]";
                    
		    $ar_results[$k][0] = "$host&nbsp;[<a&nbsp;class=\"link\"&nbsp;href=\"index.php?daily=1&sort=total&flag=ASC&year=$_GET[year]&month=$_GET[month]&day=$ar_days[$k]\">$_GET[year]-$_GET[month]-$ar_days[$k]". "</a>]";
		    $ar_results[$k][1] = $in;
                    $ar_results[$k][2] = $out;
                    $ar_results[$k][3] = $total;
                
		    $sum_in += $in;
                    $sum_out += $out;
                    $sum_total += $total;
                }
            }
        }
    }
}

for ($i = 0; $i < $k; $i++) {
    if (isset($ar_results[$i][0])) {
        $line = $ar_results[$i][0] . " " . $ar_results[$i][1] . " " . $ar_results[$i][2] . " " . $ar_results[$i][3];
        array_push($ar_results_all, $line);
    }
}

if($_GET['flag'] == "ASC") {
    $datas = sortbycol($ar_results_all, $s, SORT_ASC);
}
else {
    $datas = sortbycol($ar_results_all, $s, SORT_DESC);
}
                        

for($i=0; $i < count($datas); $i++) {
    if(strlen($datas[$i]) != 0) {
        $elements = preg_split("/[\s]+/", $datas[$i]);
        
        $host = $elements[0];
        $in = $elements[1];
        $out = $elements[2];
        $total = $elements[3];
	
        //background color
        $style = set_table_bg_style($elements[$s]);
	
	$host = ereg_replace("&nbsp;", " ", $host);
	
        $tmp = $i + 1;
        
        html_make_result_host($style, $tmp, $host, $in, $out, $total);
    }
}

html_make_sum($sum_in, $sum_out, $sum_total);

html_make_empty_table();

html_make_version_table($string[1], $string[3], $string[9], $string[13], $version);

?>
